#include <iostream>
using namespace std;

int recursiveCallsA=0;
int recursiveCallsB=0;
int recursiveCallsC=0;

double iterativeA(int n);
double recursiveA(int n);
int iterativeB(int n);
int iterativeIIB(int n);
int recursiveB(int n);
double iterativeIC(int n,int x,int y,int z);
double iterativeIIC(int n,int x,int y,int z);
double recursiveC(int n,int x,int y,int z);


void main(){
	int n;
	cout << "Please enter a strictly positive integer n " << endl;
	cin  >> n;
	cout << "iterativeA(" << n << ") = " << iterativeA(n) << endl;
	cout << "recursiveA(" << n << ") = " << recursiveA(n) << endl;
	cout << "The number of calls for function recursiveA is : " << recursiveCallsA << endl;	
	cout << "iterativeB(" << n << ") = " << iterativeB(n) << endl;	
	cout << "iterativeIIB(" << n << ") = " << iterativeIIB(n) << endl;	
	cout << "recursiveB(" << n << ") = " << recursiveB(n) << endl;
	cout << "The number of calls for function recursive B is : " << recursiveCallsB << endl;
	cout << "Please enter three integers x,y,z separated by spaces " << endl;
	int x,y,z;
	cin >> x >> y >> z;
	cout << "iterativeIC(" << n << ", " << x << ", " << y  << ", " << z << ") = " << iterativeIC(n,x,y,z) << endl;
	cout << "iterativeIIC(" << n << ", " << x << ", " << y  << ", " << z << ") = " << iterativeIIC(n,x,y,z) << endl;
	cout << "recursiveC(" << n << ", " << x << ", " << y  << ", " << z << ") = " << recursiveC(n,x,y,z) << endl;
	cout << "The number of calls for function recursive C is : " << recursiveCallsC << endl;

	
}

double iterativeA(int n){
	double a=0;
	double previous = 0;
	for(double i=1;i<=n;i++){
		a = 2 * previous + 1;
		previous = a;
	}
	return a;
}
double recursiveA(int n){
	recursiveCallsA++;
	if(n==1) return 1;
	else return 2*recursiveA(n-1)+1;
}
int iterativeB(int n){
	
	//the last entry has index n,to be able to start the array at index 1
	int *b = new int[n+1];  
	b[1] = 1;
	for(int i=2;i<=n;i++){
		b[i] = b[i/2] + b[(i+1)/2] + i;
	}
	int returnValue = b[n];
	delete [] b;
	return returnValue;
}



int recursiveB(int n){
	recursiveCallsB++;
	if(n==1) return 1;
	else { //This is MUCH faster than simply returning (recursiveB(n/2) + recursiveB((n+1)/2) + n;
			//try both methods with n=50000000 and see the difference!
		if(n%2==0) return 2*recursiveB(n/2) + n;
		else return (recursiveB(n/2) + recursiveB((n+1)/2) + n);
	}
}

double iterativeIC(int n, int x, int y, int z){
	if(n==1) return x;
	if(n==2) return y;
	if(n==3) return z;
	double current = z;
	double previous = y;
	double beforePrevious = x;
	int count = 3;
	while(count<n){
		double temp = current + previous + beforePrevious;
		beforePrevious = previous;
		previous = current;
		current = temp;	
		count++;
	}
	return current;
}

double iterativeIIC(int n, int x, int y, int z){
	if(n==1) return x;
	if(n==2) return y;
	if(n==3) return z;

	double *c = new double [n+1]; 
	c[1] = x;
	c[2] = y;
	c[3] = z;
	for(int i=4;i<=n;i++)
		c[i] = c[i-1]+c[i-2]+c[i-3];
	double returnValue = c[n];
	delete [] c;
	return returnValue;
}
double recursiveC(int n, int x, int y, int z){
	recursiveCallsC++;
	if(n==1) return x;
	else if(n==2) return y;
	else if(n==3) return z;
	else return (recursiveC(n-1,x,y,z)+recursiveC(n-2,x,y,z)+recursiveC(n-3,x,y,z));
}

//recursiveC is highly inefficient when compared to iterativeIC and iterativeIIC
//because in the iterative version, the number of steps the program makes is 
//proportional to n, while in the recursive version it is proportional to the 
//number of recursive calls, which is much larger than n: suppose you want 
//to compute C(50). then ,say, C(45) will be called multiple times:
//1: C(50)->C(49)->C(48)->C(47)->C(46)->C(45)
//2: C(50)->C(49)->C(48)->C(47)->C(45)
//3: C(50)->C(49)->C(48)->C(45)
//4: C(50)->C(49)->C(47)->C(46)->C(45)
//5: ....And so on and so forth. This effect increases as one goes deeper in the recursion
//the base cases are called millions and millions of times.


//For similar reasons, iterativeIIB is much faster than recursiveB.
//As to iterativeB and recursiveB, recusiveB is much faster and requires
//much less memory, but it would have been slower if we had used a
//naive implementation that would not distinguish between odd and even n.
//the reason why recursiveB is much faster than iterativeB is that 
//recursiveB computes only a fraction of the array entries, and
//it is much less memory consuming (since recursion depth is bounded
//by the logarithm of n) 


// OPTIONAL
// iterative B without array 

//iterative solution without arrays.
//The basic idea of iterativeIIB is that the only values of the sequence b
//that will ever need to be calculated are the values b(floor(n/2^i)) and b(floor(n/2^i)+1)
//where i goes from 0 to lg n . This is a bit tricky to prove, and not required for exam.

//Actually it turns out that this recurrence has a closed form solution:
//a(n) = n*(floor(log_2 n) + 3) - 2^((floor (log_2 n)) + 1)
//see http://www.research.att.com/~njas/sequences/A033156

int iterativeIIB(int n){  
	int low = 1, high = 2;
	int bLow = 1, bHigh = 4,newLow,newHigh,newBLow,newBHigh;

	int n1;
	while(low<n){
		n1 = n;
		while(n1/2>low){
			n1 = n1/2;
		}
		newLow = n1;
		newHigh = n1+1;
		if(n1%2==0){
			newBLow = 2*bLow + newLow;
			newBHigh = bLow+bHigh + newHigh;
		}
		else{
			newBLow = bLow + bHigh + newLow;
			newBHigh = 2 * bHigh +newHigh;
		}
		bLow = newBLow;
		bHigh = newBHigh;
		low = newLow;
		high = newHigh;
	}
	return bLow;
}
