#include <iostream>
#include <ctime>
using namespace std;

int partition(int *,int,int);
void printArray(const int *A,int n);
void randQuickSort(int A[], int low, int high);
void quickSort(int A[], int low, int high);
void testQuickSort();
void testRandQuickSort();

void main()
{
	//srand is called only *once* at the beginning of the program.
	//Do not call srand repeatedly, for instance within a loop, because if the time interval
	//between 2 consecutive calls is too small, the random number generator will be seeded with the 
	//same value.
	srand((unsigned)time(NULL));
	testQuickSort();
	testRandQuickSort();
	
}
void testQuickSort(){
	int A[]= {14,2, 11,13,6,5,15,9,8, 12, 3, 10, 4, 1, 7};
	cout<<"orginal array:"<<endl;
	printArray(A,15);
	quickSort(A,0,14);
	cout<<"after calling quicksort:"<<endl;
	printArray(A,15);
}
void testRandQuickSort(){
	int A[]= {14,2, 11,13,6,5,15,9,8, 12, 3, 10, 4, 1, 7};
	cout<<"orginal array:"<<endl;
	printArray(A,15);
	randQuickSort(A,0,14);
	cout<<"after calling randquicksort:"<<endl;
	printArray(A,15);
}

void quickSort(int A[], int low, int high){
	if(high>low){
		int q = partition(A,low,high);
		quickSort(A,low,q-1);
		quickSort(A,q+1,high);
	}
}
void randQuickSort(int A[], int low, int high){
	if(high>low){
		int randomIndex = low + rand()%(high-low+1);
		swap(A[randomIndex],A[high]);
		int q = partition(A,low,high);
		randQuickSort(A,low,q-1);
		randQuickSort(A,q+1,high);
	}
}


//to see why  this implementation of partitioning works , observe that the following
//properties hold:
//1-At every step of the outer while loop i and j are between low and high included, because the initial 
// value of i is a lower bound on j and the initial value of j is an upper bound on i.This means that
// no out of bounds error is possible.
//2-At every step of the outer while loop, all elements of index strictly smaller than i, if any exists, are smaller
//or equal to A[high]. 
//3-At every step of the outer while loop, all elements of index strictly larger than j are larger or equal to A[high],
//and at least one such element exists (namely A[high]);
//4-When the outer while loop exits, we have i==j. Exactly one of three cases must hold:
	//1-A[i]>A[high]
	//2-A[i]= A[high]
	//3-A[i]<A[high] 
	//In the first 2 cases, we can just swap A[i] with A[high], and we're done.
	//In the last case, since we have i==j, and since at any time A[j+1]>=A[high],
	//we can swap A[j+1] with A[high] (A[j+1] is not out of bounds, since the maximum
	//value of j, which happens to be its initial value,is high-1)

int partition(int A[],int low,int high)
{
    int i=low;
	if(high-low<1) return 0;
    int j=high-1;
    while (i<j) {
      	while (A[i]<=A[high] && i<j)
	    	i++;
	    while (A[j]>=A[high] && i<j)
		    j--;
		swap(A[i],A[j]);
    }   
	if(A[i]>=A[high])  {
		swap(A[i],A[high]);
		return i; 
	}
	else {
		swap(A[i+1],A[high]);
		return i+1;
	}
}

void printArray(const int *A,int n)
{
	for (int i=0;i<n;i++) 
		cout<<A[i]<<" ";
	cout<<endl;
}
